class LlamaForCausalLM(Module):
  __parameters__ = []
  __buffers__ = []
  def forward(self: __torch__.transformers.models.llama.modeling_llama.___torch_mangle_154.LlamaForCausalLM,
    input_ids: Tensor,
    attention_mask: Tensor,
    position_ids: Tensor,
    past_key_values: Tuple[Tuple[Tensor, Tensor, Tensor, Tensor], Tuple[Tensor, Tensor, Tensor, Tensor]]) -> Tuple[Tensor, Tuple[Tuple[Tensor, Tensor, Tensor, Tensor], Tuple[Tensor, Tensor, Tensor, Tensor]]]:
    _0, _1, = past_key_values
    _2, _3, _4, _5, = _0
    _6, _7, _8, _9, = _1
    _10 = torch.size(input_ids, 1)
    query_length = ops.prim.NumToTensor(_10)
    past_key_values_length = ops.prim.NumToTensor(torch.size(_2, 2))
    y = torch.embedding(CONSTANTS.c0, input_ids, 0)
    key_value_length = torch.add(query_length, past_key_values_length)
    _11 = torch.size(attention_mask, 0)
    past_key_values_length0 = torch.sub(key_value_length, query_length)
    mask = torch.full([_10, _10], -3.4028234663852886e+38, dtype=None, layout=None, device=torch.device("cpu"), pin_memory=False)
    mask_cond = torch.arange(torch.size(mask, -1), dtype=None, layout=None, device=torch.device("cpu"), pin_memory=False)
    _12 = torch.view(torch.add(mask_cond, CONSTANTS.c1), [torch.size(mask, -1), 1])
    mask0 = torch.masked_fill_(mask, torch.lt(mask_cond, _12), 0)
    mask1 = torch.to(mask0, 6)
    _13 = torch.unsqueeze(torch.unsqueeze(mask1, 0), 1)
    _14 = torch.slice(_13, 2, 0, 9223372036854775807)
    _15 = torch.slice(_14, 3, 0, 9223372036854775807)
    _16 = torch.add(query_length, past_key_values_length0)
    causal_4d_mask = torch.expand(_15, [_11, 1, _10, int(_16)])
    _17 = torch.size(attention_mask, 1)
    _18 = torch.slice(attention_mask, 0, 0, 9223372036854775807)
    _19 = torch.unsqueeze(torch.unsqueeze(_18, 1), 2)
    _20 = torch.slice(_19, 3, 0, 9223372036854775807)
    _21 = torch.expand(_20, [_11, 1, _10, _17])
    inverted_mask = torch.rsub(torch.to(_21, 6), 1.)
    _22 = torch.masked_fill(inverted_mask, torch.to(inverted_mask, 11), -3.4028234663852886e+38)
    expanded_attn_mask = torch.to(_22, dtype=6, layout=0, device=torch.device("cpu"))
    _23 = torch.masked_fill(causal_4d_mask, torch.to(expanded_attn_mask, 11), -3.4028234663852886e+38)
    hidden_states = ops.torch_ipex.rmsnorm(y, CONSTANTS.c2, 1.0000000000000001e-05)
    _24 = torch.size(hidden_states, 0)
    _25 = torch.size(hidden_states, 1)
    seq_len = ops.prim.NumToTensor(_25)
    past_len = ops.prim.NumToTensor(torch.size(_2, -2))
    seq_len0 = torch.add(seq_len, past_len)
    x = torch.to(hidden_states, 6)
    x0 = torch.contiguous(x)
    x1 = torch.to(x0, 6)
    x2 = torch.contiguous(x1)
    x3 = torch.to(x2, 6)
    hidden_states0 = torch.contiguous(x3)
    _26 = torch.size(hidden_states0, 0)
    _27 = torch.size(hidden_states0, 1)
    x4 = torch.to(hidden_states0, 6)
    x5 = torch.contiguous(x4)
    _28 = ops.torch_ipex.tpp_linear(x5, CONSTANTS.c3, 64)
    _29 = torch.view(_28, [_26, _27, 4, 16])
    x6 = torch.to(x5, 6)
    x7 = torch.contiguous(x6)
    _30 = ops.torch_ipex.tpp_linear(x7, CONSTANTS.c4, 32)
    _31 = [_26, _27, 2, 16]
    _32 = torch.view(_30, _31)
    x8 = torch.to(x7, 6)
    _33 = ops.torch_ipex.tpp_linear(torch.contiguous(x8), CONSTANTS.c5, 32)
    _34 = torch.view(_33, _31)
    position_ids0 = torch.contiguous(position_ids)
    _35 = torch.to(seq_len0, torch.device("cpu"), 4, False, True)
    _36, _37, _38, _39 = ops.myops.longrope(CONSTANTS.c6, CONSTANTS.c7, CONSTANTS.c7, CONSTANTS.c8, CONSTANTS.c9, CONSTANTS.c10, None, None, None, torch.contiguous(_35), CONSTANTS.c11)
    _40, _41, _42 = ops.torch_ipex.rotary_position_embedding(_32, _37, position_ids0, 2, 16, 8, 16)
    position_ids1 = torch.contiguous(position_ids0)
    query, _43, _44 = ops.torch_ipex.rotary_position_embedding(_29, _37, position_ids1, 4, 16, 8, 16)
    _45 = torch.contiguous(_3)
    _46 = torch.contiguous(_4)
    _47 = torch.contiguous(_5)
    _48 = torch.to(past_len, torch.device("cpu"), 4, False, True)
    attn_output, _49, _50, _51, _52 = ops.torch_ipex.masked_multihead_self_attention(query, _40, _34, _45, _46, _47, torch.contiguous(_48), 4., 4096, None, _23, True)
    _53 = ops.prim.NumToTensor(torch.size(query, 1))
    _54 = int(torch.add(past_len, _53))
    _55 = torch.empty([1, _54, _54, 1], dtype=4, layout=None, device=torch.device("cpu"), pin_memory=False)
    _56 = torch.contiguous(_55)
    x9 = torch.reshape(torch.transpose(attn_output, 1, 2), [_24, _25, 64])
    x10 = torch.to(x9, 6)
    x11 = torch.contiguous(x10)
    y0 = torch.to(y, 6)
    _57 = torch.contiguous(y0)
    _58 = torch.new_empty(x11, [0], dtype=None, layout=None, device=None, pin_memory=False)
    y1 = ops.torch_ipex.tpp_linear_add(x11, _57, CONSTANTS.c12, _58, 1., 64)
    _59 = ops.torch_ipex.rmsnorm(y1, CONSTANTS.c2, 1.0000000000000001e-05)
    input = ops.torch_ipex.ipex_MKLSGEMM(_59, CONSTANTS.c14, None, (CONSTANTS.c13).get_data_handle(), 172)
    _60 = torch.silu(input)
    _61 = ops.torch_ipex.ipex_MKLSGEMM(_59, CONSTANTS.c14, None, (CONSTANTS.c15).get_data_handle(), 172)
    _62 = ops.torch_ipex.ipex_MKLSGEMM(torch.mul(_60, _61), CONSTANTS.c14, None, (CONSTANTS.c16).get_data_handle(), 64)
    y2 = torch.add(_62, y1)
    hidden_states1 = ops.torch_ipex.rmsnorm(y2, CONSTANTS.c2, 1.0000000000000001e-05)
    _63 = torch.size(hidden_states1, 0)
    _64 = torch.size(hidden_states1, 1)
    seq_len1 = ops.prim.NumToTensor(_64)
    past_len0 = ops.prim.NumToTensor(torch.size(_6, -2))
    seq_len2 = torch.add(seq_len1, past_len0)
    x12 = torch.to(hidden_states1, 6)
    x13 = torch.contiguous(x12)
    x14 = torch.to(x13, 6)
    x15 = torch.contiguous(x14)
    x16 = torch.to(x15, 6)
    hidden_states2 = torch.contiguous(x16)
    _65 = torch.size(hidden_states2, 0)
    _66 = torch.size(hidden_states2, 1)
    x17 = torch.to(hidden_states2, 6)
    x18 = torch.contiguous(x17)
    _67 = ops.torch_ipex.tpp_linear(x18, CONSTANTS.c17, 64)
    _68 = torch.view(_67, [_65, _66, 4, 16])
    x19 = torch.to(x18, 6)
    x20 = torch.contiguous(x19)
    _69 = ops.torch_ipex.tpp_linear(x20, CONSTANTS.c18, 32)
    _70 = [_65, _66, 2, 16]
    _71 = torch.view(_69, _70)
    x21 = torch.to(x20, 6)
    _72 = ops.torch_ipex.tpp_linear(torch.contiguous(x21), CONSTANTS.c19, 32)
    _73 = torch.view(_72, _70)
    position_ids2 = torch.contiguous(position_ids1)
    _74 = torch.to(seq_len2, torch.device("cpu"), 4, False, True)
    _75, _76, _77, _78 = ops.myops.longrope(CONSTANTS.c6, CONSTANTS.c7, CONSTANTS.c7, CONSTANTS.c8, CONSTANTS.c9, CONSTANTS.c10, None, None, None, torch.contiguous(_74), CONSTANTS.c11)
    _79, _80, _81 = ops.torch_ipex.rotary_position_embedding(_71, _76, position_ids2, 2, 16, 8, 16)
    query0, _82, _83 = ops.torch_ipex.rotary_position_embedding(_68, _76, torch.contiguous(position_ids2), 4, 16, 8, 16)
    _84 = torch.contiguous(_7)
    _85 = torch.contiguous(_8)
    _86 = torch.contiguous(_9)
    _87 = torch.to(past_len0, torch.device("cpu"), 4, False, True)
    attn_output0, _88, _89, _90, _91 = ops.torch_ipex.masked_multihead_self_attention(query0, _79, _73, _84, _85, _86, torch.contiguous(_87), 4., 4096, None, _23, True)
    _92 = ops.prim.NumToTensor(torch.size(query0, 1))
    _93 = int(torch.add(past_len0, _92))
    _94 = torch.empty([1, _93, _93, 1], dtype=4, layout=None, device=torch.device("cpu"), pin_memory=False)
    _95 = torch.contiguous(_94)
    x22 = torch.reshape(torch.transpose(attn_output0, 1, 2), [_63, _64, 64])
    x23 = torch.to(x22, 6)
    x24 = torch.contiguous(x23)
    y3 = torch.to(y2, 6)
    _96 = torch.contiguous(y3)
    _97 = torch.new_empty(x24, [0], dtype=None, layout=None, device=None, pin_memory=False)
    y4 = ops.torch_ipex.tpp_linear_add(x24, _96, CONSTANTS.c20, _97, 1., 64)
    _98 = ops.torch_ipex.rmsnorm(y4, CONSTANTS.c2, 1.0000000000000001e-05)
    input0 = ops.torch_ipex.ipex_MKLSGEMM(_98, CONSTANTS.c14, None, (CONSTANTS.c21).get_data_handle(), 172)
    _99 = torch.silu(input0)
    _100 = ops.torch_ipex.ipex_MKLSGEMM(_98, CONSTANTS.c14, None, (CONSTANTS.c22).get_data_handle(), 172)
    _101 = ops.torch_ipex.ipex_MKLSGEMM(torch.mul(_99, _100), CONSTANTS.c14, None, (CONSTANTS.c23).get_data_handle(), 64)
    x25 = ops.torch_ipex.rmsnorm(torch.add(_101, y4), CONSTANTS.c2, 1.0000000000000001e-05)
    x26 = torch.to(x25, 6)
    logits = ops.torch_ipex.tpp_linear(torch.contiguous(x26), CONSTANTS.c24, 32000)
    _102 = torch.to(logits, 6)
    _103 = ((_56, _50, _51, _52), (_95, _89, _90, _91))
    return (_102, _103)
